<template>
  <div class="materialInformation">
    <!-- <div class="left-tree">
      <el-tree
        accordion
        :data="treeData"
        :props="defaultProps"
        @node-click="handleNodeClick"
      ></el-tree>
    </div> -->
    <div class="common-page-shadow">
      <div class="common-search-container" ref="contentPanel">
        <el-form
          ref="form"
          label-position="right"
          :inline="true"
          type="flex"
          justify="left"
        >
          <el-form-item label="编号">
            <el-input
              size="small"
              v-model="querys[0].value"
              clearable
              placeholder="请输入编号"
            ></el-input>
          </el-form-item>
          <el-form-item label="评标因素">
            <el-input
              size="small"
              v-model="querys[1].value"
              clearable
              placeholder="请输入评标因素"
            ></el-input>
          </el-form-item>
        </el-form>
        <div class="container-btn">
          <el-button
            size="small"
            icon="el-icon-search"
            type="danger"
            class="btn btn-plus"
            @click="handleSearch"
          >
            搜索
          </el-button>
          <el-button
            size="small"
            icon="el-icon-refresh-right"
            class="btn btn-plus"
            @click="clearSearchForm"
          >
            重置
          </el-button>
        </div>
      </div>
      <el-row
        class="common-table-container flex searchPanel"
        :style="SearchPanel"
      >
        <el-col :span="24" class="common-table-wrapper">
          <div class="common-btn-group">
            <!-- <el-button
              size="small"
              icon="el-icon-plus"
              type="primary"
              class="btn btn-plus"
              @click="handleAdd"
            >
              新增
            </el-button>
            <el-button
              :disabled="handleDeleteActive"
              size="small"
              type="danger"
              icon="el-icon-delete"
              @click="handleDelete"
            >
              删除
            </el-button>
            <el-button
              size="small"
              icon="el-icon-bottom"
              type="primary"
              plain
              class="btn btn-plus"
              @click="dataExport"
            >
              导出数据
            </el-button> -->
          </div>
          <!-- LJ：表格高度自适应需配合样式  btn-pagenation 有按钮有分页  btngroup只有按钮  pagenation只有分页 -->
          <div class="common-table-content btn-pagenation" ref="tableContent">
            <el-table
              :border="true"
              stripe
              fit
              size="mini"
              :max-height="tableHeight"
              v-loading="tableLoading"
              ref="multipleSelection"
              :data="tableData"
              @selection-change="handleSelectionChange"
              @row-dblclick="handleDetail"
            >
              <el-table-column type="selection" min-width="20%" align="center">
              </el-table-column>
              <!-- <el-table-column
                prop="pname"
                min-width="10%"
                label="根节点"
                align="center"
                resizable
              >
              </el-table-column> -->
              <el-table-column
                prop="subjectCode"
                show-overflow-tooltip
                min-width="10%"
                align="center"
                label="编号"
                resizable
              >
              </el-table-column>
              <el-table-column
                prop="subjectName"
                show-overflow-tooltip
                min-width="10%"
                align="center"
                label="评标因素"
                resizable
              >
              </el-table-column>
              <!-- <el-table-column
                prop="sn"
                show-overflow-tooltip
                min-width="10%"
                align="center"
                label="排序号"
                resizable
              >
              </el-table-column> -->
              <!-- <el-table-column min-width="10%" align="center" label="操作">
                <template v-slot="{row}">
                  <template>
                    <el-button
                      icon="el-icon-edit"
                      type="primary"
                      plain
                      size="small"
                      @click="handleEdit(row)"
                      >编辑</el-button
                    >
                  </template>
                </template>
              </el-table-column> -->
            </el-table>
          </div>
          <div class="common-pagenation">
            <el-pagination
              ref="paginationPanel"
              background
              @size-change="handleSizeChange"
              @current-change="handleCurrentChange"
              :current-page="queryParam.pageBean.page"
              :page-sizes="[20, 30, 40, 50]"
              :page-size="queryParam.pageBean.pageSize"
              layout="total, sizes, prev, pager, next, jumper"
              :total="queryParam.pageBean.total"
            >
            </el-pagination>
          </div>
        </el-col>
      </el-row>
    </div>
  </div>
</template>

<script>
import pagination from '@/components/pagination'
import {TableMixin} from '@/mixins/tableMixin'
import basicData from '@/api/basicData'
export default {
  name: 'evaluationManagement',
  components: {
    pagination
  },
  mixins: [TableMixin],
  data() {
    return {
      treeData: [], //左边树
      defaultProps: {
        children: 'children',
        id: 'id',
        label: 'subjectName'
      },
      tableHeight: 1000,
      tableData: [],
      handleDeleteActive: true,
      handleDeleteId: [],
      tableLoading: false,
      queryParam: {
        pageBean: {
          page: 1,
          pageSize: 20,
          total: 0
        }
      },

      querys: [
        {
          group: 'main',
          operation: 'LIKE',
          parentGroup: '',
          property: 'subjectCode',
          relation: 'AND',
          value: ''
        },
        {
          group: 'main',
          operation: 'LIKE',
          parentGroup: '',
          property: 'subjectName',
          relation: 'AND',
          value: ''
        },
        {
          group: 'main',
          operation: 'EQUAL',
          parentGroup: '',
          property: 'pcode',
          relation: 'AND',
          value: ''
        },
        {
          group: 'main',
          operation: 'NOT_EQUAL',
          parentGroup: '',
          property: 'id',
          relation: 'AND',
          value: '1'
        }
      ]
    }
  },
  mounted() {
    //页面缩放从新计算表格的高度
    window.addEventListener('resize', this.calcTableHeight)
  },
  created() {
    this.selectTree()
    this.loadData()
  },
  beforeDestroy() {
    window.removeEventListener('resize', this.calcTableHeight)
  },
  methods: {
    //导出数据
    dataExport() {
      this.queryParam.querys = []
      if (this.querys[0].value) {
        this.queryParam.querys.push(this.querys[0])
      }
      if (this.querys[1].value) {
        this.queryParam.querys.push(this.querys[1])
      }
      if (this.querys[2].value) {
        this.queryParam.querys.push(this.querys[2])
      }
      basicData.bizMaterialExportExcelData(this.queryParam).then(res => {
        console.log(res)
      })
    },
    // 动态计算表格的高度，自适应当前容器
    calcTableHeight() {
      this.tableHeight = this.$refs.tableContent.offsetHeight
    },
    //查询物料分类树结构
    selectTree() {
      basicData.bizEvaluationItemSelectTree().then(res => {
        this.treeData = res.value[0].children
        this.treeData.unshift({
          subjectName: '全部',
          id: ''
        })
      })
    },
    //树形控价
    handleNodeClick(data) {
      this.querys[2].value = data.id
      this.loadData()
    },
    //获取数据
    loadData() {
      this.tableLoading = true
      this.queryParam.querys = []
      if (this.querys[0].value) {
        this.queryParam.querys.push(this.querys[0])
      }
      if (this.querys[1].value) {
        this.queryParam.querys.push(this.querys[1])
      }
      if (this.querys[2].value) {
        this.queryParam.querys.push(this.querys[2])
      }
      if (this.querys[3].value) {
        this.queryParam.querys.push(this.querys[3])
      }
      basicData.bizEvaluationItemQuery(this.queryParam).then(res => {
        this.queryParam.pageBean.total = res.total
        this.tableLoading = false
        this.tableData = res.rows
        if(this.tableData!=0){
          this.tableData.forEach(item=>{
            if(item.pcode==1){
              item.pname='评分大项'
            }
          })
        }
      })
    },
    //添加
    handleAdd() {
      this.$router.push('evaluationManagementAddDialog')
    },
    // 编辑
    handleEdit(rows) {
      this.$refs.form.clearValidate()
      this.$router.push({
        name: 'evaluationManagementAddDialog',
        query: {editRows: rows, pageBean: this.queryParam}
      })
    },
    // 详情
    handleDetail(rows) {
      this.$router.push({
        name: 'evaluationManagementDetail',
        query: {detailRows: rows, pageBean: this.queryParam}
      })
    },
    // 删除
    handleDelete() {
      this.$confirm('确定删除选中数据？', '提示', {
        confirmButtonText: '确 定',
        cancelButtonText: '取 消',
        type: 'warning'
      })
        .then(() => {
          basicData
            .bizEvaluationItemRemove(this.handleDeleteId)
            .then(res => {
              if (res.state) {
                this.$notify({
                  type: 'success',
                  message: '删除成功',
                  duration: 2000
                })
                this.loadData()
              }
            })
            .catch(res => {
              this.$notify({
                type: 'error',
                message: res.message,
                duration: 2000,
                offset: 80
              })
            })
        })
        .catch(() => {})
    },
    //重置
    clearSearchForm() {
      this.querys[0].value = ''
      this.querys[1].value = ''
      this.querys[2].value = ''
      this.querys[3].value = '1'
      this.loadData()
    },
    // 顶部搜索
    handleSearch() {
      this.loadData()
    },

    handleSelectionChange(val) {
      if (val.length !== 0) {
        this.handleDeleteActive = false
        this.handleDeleteId = val.map(item => {
          return item.id
        })
      } else {
        this.handleDeleteActive = true
      }
    },
    handleCurrentChange(page) {
      this.queryParam.pageBean = {...this.queryParam.pageBean, page}
      this.loadData(this.queryParam)
    },
    handleSizeChange(pageSize) {
      this.queryParam.pageBean = {...this.queryParam.pageBean, pageSize}
      this.loadData(this.queryParam)
    }
  },
  computed: {
    SearchPanel() {
      return {
        '--searchPanel': this.searchPanel + 'px'
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.materialInformation {
  display: flex;
  width: 100%;
  height: 100%;
  .common-page-shadow {
    width: 100%;
    height: calc(100% - 160px);
    box-sizing: border-box;
    .common-search-container {
      height: 80px;
    }
  }
  .left-tree {
    width: 200px;
    margin-right: 10px;
    padding: 10px;
    box-sizing: border-box;
    height: calc(100% - 80px);
    background-color: white;
    border-radius: 10px;
    box-shadow: 0 0.10417vw 0.625vw 0 rgba(0, 0, 0, 0.1);
  }
}

.cloumn-btn {
  border: 1px solid #2761ff;
  padding: 3px 10px;
  border-radius: 5px;
  &:nth-child(1) {
    margin-right: 5px;
  }
  &:nth-child(2) {
    margin-right: 5px;
  }
  &:nth-child(1):hover {
    background-color: #2761ff;
    color: #fff;
  }
  &:nth-child(2):hover {
    background-color: #2761ff;
    color: #fff;
  }
  // &:nth-child(2):hover {
  //   background-color: #f56c6c;
  //   color: #fff;
  //   border-color: #f56c6c;
  // }
  /deep/ i,
  span {
    font-size: 16px;
  }
}
/deep/.el-tree-node.is-current > .el-tree-node__content {
  background-color: #ebf3fa;
  color: #409eff;
  font-weight: bold;
}

/deep/ .el-tree-node__content {
  padding: 5px 0;
}

/deep/ .el-table thead tr th {
  background-color: #eee !important;
  border-right: 1px solid #dfe2e8 !important;
}
/deep/ .el-table {
  border-collapse: collapse !important;
}
</style>
